/* global oVmap, nsVmap, goog, ol, vitisApp */

/**
 * @author: Anthony Borghi
 * @Description: Fichier contenant la classe nsVmap.nsToolsManager.Urlexporter
 * cette classe permet à l'utilisateur d'exporter une url pour un autre utilisateur
 */
goog.provide('nsVmap.nsToolsManager.Compare');

goog.require('oVmap');

/**
 * @classdesc
 * Class {@link nsVmap.nsToolsManager.VmapUser}
 * @constructor
 * @export
 */
nsVmap.nsToolsManager.compare = function () {
    oVmap.log('nsVmap.nsToolsManager.Compare');
};



/**
 * Directive
 * @return {angular.Directive} The directive specs.
 * @constructor
 */
nsVmap.nsToolsManager.compare.prototype.compareDirective = function () {
    oVmap.log("nsVmap.nsToolsManager.compare.prototype.compareDirective");
    return {
        restrict: 'A',
        scope: {
            'map': '=appMap',
            'lang': '=appLang'
        },
        controller: 'AppCompareMode',
        controllerAs: 'ctrl',
        bindToController: true,
        templateUrl: oVmap['properties']['vmap_folder'] + '/' + 'template/tools/comparemapmanager.html'
    };
};

/**
 * Controler
 * @constructor
 * @param {object} $scope
 * @returns {undefined}
 * @ngInject
 */
nsVmap.nsToolsManager.compare.prototype.compareController = function ($scope, $element) {
    oVmap.log("nsVmap.nsToolsManager.compare.prototype.compareController");

    var this_ = this;

    this.$scope_ = $scope;

    /**
     * The current properties
     */
    this['properties'] = oVmap['properties'];

    /**
     * The current token
     */
    this['token'] = oVmap['properties']['token'];

    /**
     * @type {boolean}
     */
    this["useCompareMode"] = false;

    $scope.$watch("ctrl.useCompareMode", function(){
        $scope.$root["compare_enabled"] = this_["useCompareMode"];
    })

};

// Définit la directive et le controller
oVmap.module.directive('appCompareMode', nsVmap.nsToolsManager.compare.prototype.compareDirective);
oVmap.module.controller('AppCompareMode', nsVmap.nsToolsManager.compare.prototype.compareController);
