--
-- PostgreSQL database dump
--

-- Dumped from database version 9.3.14
-- Dumped by pg_dump version 9.5.6

-- Started on 2017-06-07 09:12:15 CEST

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;
-- SET row_security = off;

SET search_path = [TABLE_SCHEMA], public, pg_catalog;

--
-- TOC entry 452 (class 1259 OID 67429)
-- Name: seq_draw; Type: SEQUENCE; Schema: [TABLE_SCHEMA]; Owner: -
--


SET default_tablespace = '';

SET default_with_oids = true;
  
select s_vitis.create_role_if_not_exists('oads_user', 'NOSUPERUSER INHERIT NOCREATEDB NOCREATEROLE NOREPLICATION'); 
INSERT INTO s_vitis.privileges(rolname, description) VALUES ('oads_user', 'rôle utilisateur du module Open Ads de vMap"');

CREATE TABLE [TABLE_SCHEMA].dossier
(
  dossier_num character varying(30) NOT NULL,
  author character varying(50),
  create_date date,
  modifier character varying(50),
  update_date date,
  geom geometry(MultiPolygon,2154),
  CONSTRAINT pk_dossier_num PRIMARY KEY (dossier_num),
  CONSTRAINT enforce_dims_geom CHECK (st_ndims(geom) = 2),
  CONSTRAINT enforce_srid_geom CHECK (st_srid(geom) = 2154)
)
WITH (
  OIDS=FALSE
);
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.author  IS 'Auteur de l''enregistrement';
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.create_date  IS 'Date de création de l''enregistrement';
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.modifier  IS 'Dernier modificateur de l''enregistrement';
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.update_date  IS 'Date de la dernière mise à jour de l''enregistrement';
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.geom  IS 'Emprise globale du dossier';


CREATE TABLE [TABLE_SCHEMA].parcelle_dossier
(
  dossier_num character varying(30) NOT NULL,
  id_par character(14) NOT NULL,
  CONSTRAINT pk_dossier_num_id_par PRIMARY KEY (dossier_num, id_par)
)
WITH (
  OIDS=FALSE
);
  
   
CREATE TABLE [TABLE_SCHEMA].parcelle_oads
(
  id_par character(14) NOT NULL,
  geom geometry(MultiPolygon,2154),
  CONSTRAINT pk_id_par PRIMARY KEY (id_par),
  CONSTRAINT enforce_dims_geom CHECK (st_ndims(geom) = 2),
  CONSTRAINT enforce_srid_geom CHECK (st_srid(geom) = 2154)
)
WITH (
  OIDS=FALSE
);
COMMENT ON COLUMN [TABLE_SCHEMA].dossier.geom  IS 'geométrie de la parcelle ';

CREATE TRIGGER insert_author_date_dossier
  BEFORE INSERT
  ON [TABLE_SCHEMA].dossier
  FOR EACH ROW
  EXECUTE PROCEDURE s_vitis.insert_author_date();

CREATE TRIGGER update_modifier_date_dossier
  BEFORE UPDATE
  ON [TABLE_SCHEMA].dossier
  FOR EACH ROW
  EXECUTE PROCEDURE s_vitis.update_modifier_date();

-- Index: [TABLE_SCHEMA].dossier_geom
-- DROP INDEX [TABLE_SCHEMA].dossier_geom;

CREATE INDEX dossier_geom
  ON [TABLE_SCHEMA].dossier
  USING gist
  (geom);

-- Index: [TABLE_SCHEMA].dossier_geom
-- DROP INDEX [TABLE_SCHEMA].dossier_geom;

CREATE INDEX parcelle_oads_geom
  ON [TABLE_SCHEMA].parcelle_oads
  USING gist
  (geom);

CREATE OR REPLACE VIEW [TABLE_SCHEMA].v_dossier AS   
 SELECT dossier.dossier_num, 
        CASE
            WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 4, 5)
            WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 5, 5)
            ELSE '50'::text
        END AS code_insee, 
    v_vmap_commune.nom AS commune, 
        CASE
            WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 11, 1)
            WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 12, 1)
            ELSE NULL::text
        END AS division, 
        CASE
            WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 9, 2)
            WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 10, 2)
            ELSE NULL::text
        END AS annee_dossier, 
        CASE
            WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 1, 2)
            WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 1, 3)
            ELSE NULL::text
        END AS type_dossier, 
        CASE
            WHEN dossier.author::text IS NULL THEN 'Oui'::text
            ELSE 'Non'::text
        END AS creation_automatique, 
    dossier.author, dossier.create_date, dossier.modifier, dossier.update_date, 
    dossier.geom
   FROM [TABLE_SCHEMA].dossier
   LEFT JOIN s_cadastre.v_vmap_commune ON 
   CASE
       WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 4, 5)
       WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 5, 5)
       ELSE NULL::text
   END = v_vmap_commune.id_com::text
  WHERE 
   CASE
       WHEN length(dossier.dossier_num::text) = 15 OR length(dossier.dossier_num::text) = 17 THEN substr(dossier.dossier_num::text, 4, 5)
       WHEN length(dossier.dossier_num::text) = 16 OR length(dossier.dossier_num::text) = 18 THEN substr(dossier.dossier_num::text, 5, 5)
       ELSE NULL::text
   END ~ similar_escape(( SELECT "user".restriction
      FROM s_vitis."user"
     WHERE "user".login::name = "current_user"()), NULL::text)
  ORDER BY dossier.dossier_num DESC;

-- Rule: delete_v_dossier ON [TABLE_SCHEMA].v_dossier

-- DROP RULE delete_v_dossier ON [TABLE_SCHEMA].v_dossier;

CREATE OR REPLACE RULE delete_v_dossier AS
    ON DELETE TO [TABLE_SCHEMA].v_dossier DO INSTEAD  DELETE FROM [TABLE_SCHEMA].dossier
  WHERE dossier.dossier_num = old.dossier_num;

-- Rule: insert_v_dossier ON [TABLE_SCHEMA].v_dossier

-- DROP RULE insert_v_dossier ON [TABLE_SCHEMA].v_dossier;

CREATE OR REPLACE RULE insert_v_dossier AS
    ON INSERT TO [TABLE_SCHEMA].v_dossier DO INSTEAD  INSERT INTO [TABLE_SCHEMA].dossier ( dossier_num, author, create_date, geom)
  VALUES (new.dossier_num, "current_user"()::text, 'now'::text::date, new.geom);

-- Rule: update_v_dossier ON [TABLE_SCHEMA].v_dossier
-- DROP RULE update_v_dossier ON [TABLE_SCHEMA].v_dossier;

CREATE OR REPLACE RULE update_v_dossier AS
    ON UPDATE TO [TABLE_SCHEMA].v_dossier DO INSTEAD  UPDATE [TABLE_SCHEMA].dossier SET geom = new.geom
  WHERE dossier.dossier_num = new.dossier_num;
  

ALTER TABLE [TABLE_SCHEMA].dossier OWNER TO u_vitis;
GRANT ALL ON TABLE [TABLE_SCHEMA].dossier TO u_vitis;
GRANT SELECT, UPDATE, INSERT, DELETE ON TABLE [TABLE_SCHEMA].dossier TO oads_user;

ALTER TABLE [TABLE_SCHEMA].parcelle_dossier OWNER TO u_vitis;
GRANT ALL ON TABLE [TABLE_SCHEMA].parcelle_dossier TO u_vitis;
GRANT SELECT, UPDATE, INSERT, DELETE ON TABLE [TABLE_SCHEMA].parcelle_dossier TO oads_user;

ALTER TABLE [TABLE_SCHEMA].parcelle_oads OWNER TO u_vitis;
GRANT ALL ON TABLE [TABLE_SCHEMA].parcelle_oads TO u_vitis;
GRANT SELECT, UPDATE, INSERT, DELETE ON TABLE [TABLE_SCHEMA].parcelle_oads TO oads_user;

ALTER TABLE [TABLE_SCHEMA].v_dossier OWNER TO u_vitis;
GRANT ALL ON TABLE [TABLE_SCHEMA].v_dossier TO u_vitis;
GRANT SELECT, UPDATE, INSERT, DELETE ON TABLE [TABLE_SCHEMA].v_dossier TO oads_user;
	
	
	
